<?php
/**
* @version 1.0.0
* @package RSMembership! ePayBank 1.0.0
* @copyright (C) 2012 www.ePayBank.ir
* @license GPL, http://www.gnu.org/licenses/gpl-2.0.html
*/
error_reporting(0);
require_once "./lib/nusoap.php";
@session_start();
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.plugin.plugin' );
jimport( 'joomla.html.parameter' );

if (file_exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_rsmembership'.DS.'helpers'.DS.'rsmembership.php'))
	require_once(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_rsmembership'.DS.'helpers'.DS.'rsmembership.php');

class plgSystemRSMembershipePayBank extends JPlugin
{
	function canRun()
	{
		return file_exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_rsmembership'.DS.'helpers'.DS.'rsmembership.php');
	}

	function plgSystemRSMembershipePayBank(&$subject, $config)
	{
		parent::__construct($subject, $config);
		$this->_plugin =& JPluginHelper::getPlugin('system', 'rsmembershipePayBank');
		$this->_params = new JParameter($this->_plugin->params);

		if (!$this->canRun()) return;
		RSMembership::addPlugin('دروازه پرداخت ePayBank', 'rsmembershipePayBank');
	}
    public function onAfterRender()
    {
        if(isset($_POST['trans_id'])){
            $this->onPaymentNotification();
        }
    }

	function onMembershipPayment($plugin, $data, $extra, $membership, $transaction)
	{
		if (!$this->canRun()) return;
		if ($plugin != $this->_plugin->name) return false;
        //$id_get = $_POST['id_get'];
       // $trans_id = $_POST['trans_id'];
       
    	$api = $this->_params->get('api');
        $amount = $transaction->price;
	$_SESSION["price"]=$amount;
        $redirect = urlencode(JURI::base().'index.php?option=com_rsmembership&task=thankyou');

        $result = $this->send($api,$amount,$redirect);
        if(filter_var($result, FILTER_VALIDATE_URL)){
          
            $transaction->custom = $result;
            $html = 'در حال وصل شدن به درگاه...<META http-equiv="refresh" content="3;URL='.$result.'">';
        }else{
            $html = "در ارتباط با درگاه خطايي به وجود آمد : $result";
        }

		return $html;
	}
    public function onPaymentNotification()
    {
        if ( !$this->canRun( ) )
        {
        }
        else
        {
            $database = JFactory::getDBO();;
           
            $api = $this->_params->get('api');
            $rs = $_GET['rs'];
            $price = $_SESSION["price"];
            $result = $this->get($api,$price,$rs);
            $database->setQuery( "SELECT * FROM #__rsmembership_transactions WHERE `custom`='".$rs."' AND `status`!='completed' AND `gateway`='دروازه پرداخت ePayBank'" );
            $transaction = $database->loadObject( );
            if ( empty( $transaction ) )
            {
                echo 'اطلاعاتي در رابطه با درخواست شما يافت نشد';
            }
            else
            {

                if($result == '-33'){
                    RSMembership::approve($transaction->id);
                    $database->setQuery( "UPDATE #__rsmembership_transactions SET `hash`='".$rs."' WHERE `id`='".$transaction->id."' LIMIT 1" );
                    $database->query();
                    echo 'پرداخت شما با موفقيت صورت گرفت';
                }else{
                    echo "مشکلي در پرداخت شما صورت گرفت ، شماره خطا: $result";
                }
            }

        }
    }
    
public function send($api,$amount,$redirect){
	$client=new nusoap_client("http://epaybank.ir/secure_gateway/ariacoders.php");
	$error=$client->getError();
	if($error){
	echo "<h2>Constructor Error</h2><pre>".$error."</pre>";
	}
	//$_SESSION["price"]=$amount;
	$orderid=date('ymdhis');
	$result=$client->call("requestpayment",array($api,$redirect,$amount,"parsian",$orderid));
	$client->soap_defencoding = 'UTF-8';
	if($client->fault){
		//echo "<h2>Fault</h2><pre>";
		return $result;
		//echo "</pre>";
	}
	else
	{
	$error=$client->getError();
		if($error)
		{
			return $error;
		}
		else
		{
		
			return $result;
		
		}
    }

public function get($api,$price,$rs){
	$value=trim($price);
	if(preg_match('/^[0-9]*$/',$value))
	{
	$client=new nusoap_client("http://epaybank.ir/secure_gateway/ariacoders.php");
	$client->soap_defencoding = 'UTF-8';

	$error=$client->getError();
	if($error){
	echo "<h2>Constructor Error</h2><pre>".$error."</pre>";
	}
	$result=$client->call("verifypeyment",array($api,$value,$rs,"parsian"));
	$client->soap_defencoding = 'UTF-8';

	if($client->fault){
		//echo "<h2>Fault</h2><pre>";
		return $result;
		//echo "</pre>";
	}
	else
	{
	$error=$client->getError();
		if($error){
			 return $error;
		}
		else
		{
			return $result;
		
		}
	}
	}//if first		
    }

}
